From ec645d3429006b0f7c693a6d65f1dc196264e0a1 Mon Sep 17 00:00:00 2001
From: Robert Haas <rhaas@postgresql.org>
Date: Wed, 20 Mar 2024 10:08:05 -0400
Subject: [PATCH v1 1/4] docs: Remove the "Installation from Binaries" chapter.

The entire chapter was four sentences. Move the most useful
information from those sentences to the "Installation from Source
Code" chapter, and rename that to just "Installation".
---
 doc/src/sgml/filelist.sgml         |  1 -
 doc/src/sgml/install-binaries.sgml | 24 ------------------------
 doc/src/sgml/installation.sgml     | 23 +++++++++++++++++------
 doc/src/sgml/postgres.sgml         |  1 -
 4 files changed, 17 insertions(+), 32 deletions(-)
 delete mode 100644 doc/src/sgml/install-binaries.sgml

diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
index e0dca81cb2..b7d1222e3e 100644
--- a/doc/src/sgml/filelist.sgml
+++ b/doc/src/sgml/filelist.sgml
@@ -36,7 +36,6 @@
 <!ENTITY client-auth   SYSTEM "client-auth.sgml">
 <!ENTITY diskusage     SYSTEM "diskusage.sgml">
 <!ENTITY high-availability      SYSTEM "high-availability.sgml">
-<!ENTITY installbin    SYSTEM "install-binaries.sgml">
 <!ENTITY installation  SYSTEM "installation.sgml">
 <!ENTITY targets-meson  SYSTEM "targets-meson.sgml">
 <!ENTITY maintenance   SYSTEM "maintenance.sgml">
diff --git a/doc/src/sgml/install-binaries.sgml b/doc/src/sgml/install-binaries.sgml
deleted file mode 100644
index 001c3c7be0..0000000000
--- a/doc/src/sgml/install-binaries.sgml
+++ /dev/null
@@ -1,24 +0,0 @@
-<!-- doc/src/sgml/install-binaries.sgml -->
-<chapter id="install-binaries">
- <title>Installation from Binaries</title>
-
- <indexterm>
-  <primary>installation</primary>
-  <secondary>binaries</secondary>
- </indexterm>
-
- <para>
-  <productname>PostgreSQL</productname> is available in the form of binary
-  packages for most common operating systems today. When available, this is
-  the recommended way to install PostgreSQL for users of the system. Building
-  from source (see <xref linkend="installation" />) is only recommended for
-  people developing <productname>PostgreSQL</productname> or extensions.
- </para>
-
- <para>
-  For an updated list of platforms providing binary packages, please visit
-  the download section on the <productname>PostgreSQL</productname> website at
-  <ulink url="https://www.postgresql.org/download/"></ulink> and follow the
-  instructions for the specific platform.
- </para>
-</chapter>
diff --git a/doc/src/sgml/installation.sgml b/doc/src/sgml/installation.sgml
index a453f804cd..7b2e6786f4 100644
--- a/doc/src/sgml/installation.sgml
+++ b/doc/src/sgml/installation.sgml
@@ -1,18 +1,29 @@
 <!-- doc/src/sgml/installation.sgml -->
 
 <chapter id="installation">
- <title>Installation from Source Code</title>
+ <title>Installation</title>
 
  <indexterm zone="installation">
   <primary>installation</primary>
  </indexterm>
 
  <para>
-  This chapter describes the installation of
-  <productname>PostgreSQL</productname> using the source code
-  distribution.  If you are installing a pre-packaged distribution,
-  such as an RPM or Debian package, ignore this chapter
-  and see <xref linkend="install-binaries" /> instead.
+  Since <productname>PostgreSQL</productname> is available in the form of
+  binary packages for most common operating systems today, it is typically not
+  necessary to build from source.
+ </para>
+
+ <para>
+  For an updated list of platforms providing binary packages, please visit
+  the download section on the <productname>PostgreSQL</productname> website at
+  <ulink url="https://www.postgresql.org/download/"></ulink> and follow the
+  instructions for the specific platform.
+ </para>
+
+ <para>
+  If you wish to compile from source code, for example to develop
+  <productname>PostgreSQL</productname> or an extension, the following
+  sections explain how to do this.
  </para>
 
  <sect1 id="install-requirements">
diff --git a/doc/src/sgml/postgres.sgml b/doc/src/sgml/postgres.sgml
index 2c107199d3..7c234ff1db 100644
--- a/doc/src/sgml/postgres.sgml
+++ b/doc/src/sgml/postgres.sgml
@@ -150,7 +150,6 @@ break is not needed in a wider output rendering.
    </para>
   </partintro>
 
-  &installbin;
   &installation;
   &runtime;
   &config;
-- 
2.39.3 (Apple Git-145)